/*****************************************************
Chip type           : ATmega16
Program type        : Application
Clock frequency     : 1,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>
#include <delay.h>
#include <stdio.h>
//#include <io.h>
#define ADC_VREF_TYPE 0xC0  
#define UDRE 5
#define RXC  7
/*
unsigned char USART_Receive(void) 				//     USART
{  
	while( !( UCSRA & (1<<RXC)) );			//     
	return UDR;                                  
}

void USART_Transmit(unsigned long data)   		//     USART
{
     while( !( UCSRA & (1<<UDRE)));			//     
	UDR=data;
}     
  */
//   
int voltage[7]; //     
#pragma warn-
eeprom int voltage_e[7]; //   
#pragma warn+

//    
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
//      
delay_us(10);
//  
ADCSRA|=0x40;
//   
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

// Timer 1   
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
int k;
//       ,  10 
TCNT1H=0x67;
TCNT1L=0x6A;
//     
for (k=0; k<=7; k++)
        {
         voltage[k] = read_adc(k);
        }
}


void main(void)
{
// Declare your local variables here
int a;
//int b;

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTB=0xFF;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0xFF;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=P State6=P State5=P State4=P State3=P State2=P State1=P State0=P 
PORTD=0xFF;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 0,977 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: On
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0x67;
TCNT1L=0x6A;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 500,000 kHz
// ADC Voltage Reference: Int., cap. on AREF
// ADC Auto Trigger Source: Free Running
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0xA1;
SFIOR&=0x1F;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 4800
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x0C;

// Global enable interrupts
#asm("sei")

while (1)
      {
      
      //     "r",     
      //  "Channel-X=xxxx >= EEPROM-X=xxxx"  "Channel-X=xxxx < EEPROM-X=xxxx"
      if (UDR=='r')
      {
      //        
      for (a=0;a<=7;a++)
        {
        if (voltage[a]>=voltage_e[a])
          {
          
          PORTC = PORTC | (1 << a);
          printf("Channel-",a,"=",voltage[a]," >= EEPROM-",a,"=",voltage_e[a]);
          //USART_Transmit("Channel-",a,"=",voltage[a]," >= EEPROM-",a,"=",voltage_e[a]);
          }
       else
          {
          PORTC = PORTC & !(1 << a);
          printf("Channel-",a,"=",voltage[a]," < EEPROM-",a,"=",voltage_e[a]);
          //USART_Transmit("Channel-",a,"=",voltage[a]," < EEPROM-",a,"=",voltage_e[a]);
         
          }
        }
        }
       };
}
